VERSION 4.00
Begin VB.Form frmRectangle 
   Caption         =   "Rectangle Paint"
   ClientHeight    =   2340
   ClientLeft      =   1035
   ClientTop       =   1590
   ClientWidth     =   5910
   Height          =   2745
   Left            =   975
   LinkTopic       =   "Form1"
   ScaleHeight     =   2340
   ScaleWidth      =   5910
   Top             =   1245
   Width           =   6030
   Begin VB.PictureBox Picture1 
      Height          =   555
      Left            =   315
      ScaleHeight     =   525
      ScaleWidth      =   1605
      TabIndex        =   5
      Top             =   630
      Width           =   1635
      Begin VB.TextBox Text3 
         Height          =   285
         Left            =   135
         TabIndex        =   6
         Text            =   "Text3"
         Top             =   90
         Width           =   1005
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Frame1"
      Height          =   960
      Left            =   315
      TabIndex        =   3
      Top             =   1215
      Width           =   4695
      Begin VB.Frame Frame2 
         Caption         =   "Frame2"
         Height          =   690
         Left            =   2340
         TabIndex        =   8
         Top             =   180
         Width           =   1995
         Begin VB.OptionButton Option1 
            Caption         =   "Option1"
            Height          =   240
            Left            =   180
            TabIndex        =   9
            Top             =   315
            Width           =   1590
         End
      End
      Begin VB.TextBox Text2 
         Height          =   285
         Left            =   360
         TabIndex        =   4
         Text            =   "Text2"
         Top             =   450
         Width           =   1680
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Command2"
      Height          =   330
      Left            =   2115
      TabIndex        =   2
      Top             =   585
      Width           =   1005
   End
   Begin VB.CommandButton Command1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Command1"
      Height          =   330
      Left            =   2115
      TabIndex        =   1
      Top             =   225
      Width           =   1005
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   315
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   225
      Width           =   1635
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   375
      Left            =   4635
      TabIndex        =   7
      Top             =   270
      Width           =   690
   End
End
Attribute VB_Name = "frmRectangle"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long

Private Const PS_SOLID = &H0
Private Sub Shadow(ctl As Control)
    
    ' GDI Objects
    Dim hNewBrush As Long   ' Handle to New Brush
    Dim hOldBrush As Long   ' Handle to Old Brush
    Dim hNewPen As Long     ' Handle to new pen
    Dim hOldPen As Long     ' Handle to Old Pen
        
    Dim nReturn As Long     ' Return Values from API
    Dim nRectangle As RECT
    Dim hMainHdc As Long    ' Form's Hdc
    Dim lColor As Long      ' The Color to paint
    
    Dim ctlContainer As Object ' The container of the Ctl
    
    Dim xOffSet As Long
    Dim yOffSet As Long
    
    On Error GoTo Shadow_exit:
    
    ' The Color of the Rectangle
    lColor = RGB(256, 0, 0)
    
    ' Assign the Container of the Control to ctlContainer
    Set ctlContainer = ctl.Container
    
    ' Get the handle to the DC of the Container
    hMainHdc = GetDC(ctlContainer.hwnd)
    
    
    ' Create the new Brush
    hNewBrush = CreateSolidBrush(lColor)
    
    ' Select the new brush
    hOldBrush = SelectObject(hMainHdc, hNewBrush)
        
    ' Create the pen
    hNewPen = CreatePen(PS_SOLID, 2, lColor)
    
    ' Select the pen and hold the handle to the old pen
    hOldPen = SelectObject(hMainHdc, hNewPen)
    
    ' Get the rectangle to draw
    nReturn = GetClientRect(ctl.hwnd, nRectangle)
    
    xOffSet = ctl.Left / Screen.TwipsPerPixelX
    yOffSet = ctl.Top / Screen.TwipsPerPixelY
    
    nRectangle.Left = xOffSet - 1
    nRectangle.Right = nRectangle.Right + xOffSet - 3
    nRectangle.Top = yOffSet - 1
    nRectangle.Bottom = nRectangle.Bottom + yOffSet - 3
    
    ' Draw the Rectangle
    nReturn = Rectangle(hMainHdc, nRectangle.Left, nRectangle.Top, nRectangle.Right + 6, nRectangle.Bottom + 6)
    
    ' Replace the old brush
    nReturn = SelectObject(hMainHdc, hOldBrush)
    ' Delete The object
    nReturn = DeleteObject(hNewBrush)
    ' Replace the Old Pen
    nReturn = SelectObject(hMainHdc, hOldPen)
    ' Delete the new pen
    nReturn = DeleteObject(hNewPen)
    
    ' Release the DC
    nReturn = ReleaseDC(ctlContainer.hwnd, hMainHdc)
    
    Exit Sub
    
Shadow_exit:
    ' Exit the sub
End Sub

Public Sub ShowRectangle(ctl As Object)
    ' Paints a Square around the control
    
    Dim lLeft As Long
    Dim lRight As Long
    Dim lTop As Long
    Dim lBottom As Long
    
    Dim lLeftOffset As Long
    Dim lTopOffset As Long
    
    Dim ctlContainer As Object
    
    Set ctlContainer = ctl.Container
    
    'If TypeOf ctlContainer Is Frame Or TypeOf ctlContainer Is PictureBox Then
    '    ' Create the offset
    '    lLeftOffset = ctlContainer.Left
    '    lTopOffset = ctlContainer.Top
    'End If
        
    
    lLeft = ctl.Left - 30
    lTop = ctl.Top - 30
    
    lBottom = ctl.Top + ctl.Height + 15
    lRight = ctl.Left + ctl.Width + 15
    
    ctlContainer.DrawWidth = 3
    ctlContainer.Line (lLeft, lTop)-(lRight, lBottom), QBColor(4), B
End Sub

Private Sub Command1_Click()
    ShowRectangle Text1
End Sub

Private Sub Command2_Click()
    Shadow Text2
    'ShowRectangle Text2
End Sub


